import { type Engine, type IContainerPlugin } from "@tsparticles/engine";
import type { SoundsContainer } from "./types.js";
export declare class SoundsInstance implements IContainerPlugin {
    private _audioMap;
    private _audioSources;
    private readonly _container;
    private readonly _engine;
    private _gain?;
    private _muteImg?;
    private _unmuteImg?;
    private _volume;
    private _volumeDownImg?;
    private _volumeUpImg?;
    constructor(container: SoundsContainer, engine: Engine);
    init(): Promise<void>;
    mute(): Promise<void>;
    start(): Promise<void>;
    stop(): void;
    toggleMute(): Promise<void>;
    unmute(): Promise<void>;
    volumeDown(): Promise<void>;
    volumeUp(): Promise<void>;
    private readonly _addBuffer;
    private readonly _addOscillator;
    private _getAudioContext;
    private readonly _initEvents;
    private readonly _mute;
    private readonly _playBuffer;
    private readonly _playFrequency;
    private readonly _playMuteSound;
    private readonly _playNote;
    private readonly _playNoteValue;
    private readonly _removeAudioSource;
    private readonly _unmute;
    private readonly _updateMuteIcons;
    private readonly _updateMuteStatus;
    private readonly _updateVolume;
}
