(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "@tsparticles/engine", "./SoundsNote.js"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.SoundsMelody = void 0;
    const engine_1 = require("@tsparticles/engine");
    const SoundsNote_js_1 = require("./SoundsNote.js");
    class SoundsMelody {
        constructor() {
            this.loop = false;
            this.melodies = [];
            this.notes = [];
        }
        load(data) {
            if ((0, engine_1.isNull)(data)) {
                return;
            }
            if (data.loop !== undefined) {
                this.loop = data.loop;
            }
            if (data.melodies !== undefined) {
                this.melodies = data.melodies.map(s => {
                    const tmp = new SoundsMelody();
                    tmp.load(s);
                    return tmp;
                });
            }
            if (data.notes !== undefined) {
                this.notes = data.notes.map(s => {
                    const tmp = new SoundsNote_js_1.SoundsNote();
                    tmp.load(s);
                    return tmp;
                });
            }
        }
    }
    exports.SoundsMelody = SoundsMelody;
});
