(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "@tsparticles/engine"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.SoundsVolume = void 0;
    const engine_1 = require("@tsparticles/engine");
    class SoundsVolume {
        constructor() {
            this.value = 100;
            this.max = 100;
            this.min = 0;
            this.step = 10;
        }
        load(data) {
            if ((0, engine_1.isNull)(data)) {
                return;
            }
            if ((0, engine_1.isObject)(data)) {
                if (data.max !== undefined) {
                    this.max = data.max;
                }
                if (data.min !== undefined) {
                    this.min = data.min;
                }
                if (data.step !== undefined) {
                    this.step = data.step;
                }
                if (data.value !== undefined) {
                    this.value = data.value;
                }
            }
            else {
                this.value = data;
            }
        }
    }
    exports.SoundsVolume = SoundsVolume;
});
