(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "@tsparticles/engine", "./SoundsPlugin.js"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.loadSoundsPlugin = loadSoundsPlugin;
    const engine_1 = require("@tsparticles/engine");
    const SoundsPlugin_js_1 = require("./SoundsPlugin.js");
    async function loadSoundsPlugin(engine, refresh = true) {
        (0, engine_1.assertValidVersion)(engine, "3.7.1");
        await engine.addPlugin(new SoundsPlugin_js_1.SoundsPlugin(engine), refresh);
    }
});
